/* 
 * thinc_zsound_priv.h: private stuff for encoding/decoding library. outside
 * code should not include this.
 *
 * Authors: 
 * Ricardo A. Baratto - Network Computing Lab - Columbia University
 */

/* set tabstop = 8 */

#ifndef __TZ_IN_LIB
#error "please don't use from outside the library"
#endif

#ifndef _THINC_ZSOUND_PRIV_H_
#define _THINC_ZSOUND_PRIV_H_

/* so i don't have to type that much... */
#define tz_func_init(name)	\
	static int tz_init_##name(struct thinc_zsound *, va_list)
#define tz_func_end(name)	\
	static void tz_end_##name(struct thinc_zsound*)
#define tz_func_prepare(name)	\
	static int tz_prepare_##name(struct thinc_zsound*)
#define tz_func_encode(name)	\
	static int tz_encode_##name(struct thinc_zsound*, char *, \
		unsigned int)
#define tz_func_decode(name)	\
	static int tz_decode_##name(struct thinc_zsound*, char *, int)
#define tz_func_finish(name)	\
	static int tz_finish_##name(struct thinc_zsound*)

#define tz_funcs_enc(name)	\
tz_func_init(name);		\
tz_func_end(name);		\
tz_func_prepare(name);		\
tz_func_encode(name);		\
tz_func_finish(name);

#define tz_funcs_dec(name)	\
tz_func_init(name);		\
tz_func_end(name);		\
tz_func_prepare(name);		\
tz_func_decode(name);		\
tz_func_finish(name);

#if 0
#define TZ_DO_DEBUG
#endif

#ifdef TZ_DO_DEBUG
#include <stdio.h>
#define TZ_DEBUG(...)	fprintf(stderr, ## __VA_ARGS__)
#else
#define TZ_DEBUG(...)
#endif

#endif	/* _THINC_ZSOUND_PRIV_H_ */
