/**************************************************************************
 *
 * Copyright 2002-2006 Columbia University
 * All Rights Reserved
 *
 **************************************************************************/
/*
 * Common definitions for all of thinc
 *
 * Authors: 
 * Ricardo A. Baratto - Network Computing Lab - Columbia University
 */

/* set tabstop = 8 */

#ifndef _THINC_COMMON_H_
#define _THINC_COMMON_H_

/* Return values
 * All functions should use these return values. If you need different, 
 * or yours have different meaning, define and document them here. Don't 
 * just use literal numbers or i'll hunt you down */
#define T_OK	1
#define T_ERROR	-1

#define T_TRUE	1
#define T_FALSE 0
#define T_YES 	T_TRUE
#define T_NO 	T_FALSE

/* server defined return values */
#define T_CLOSED 	0
#define T_WOULDBLOCK	-2
#define T_TIMEOUT 	-3

#define T_STOP		2	/* stops execution of a message */

/*
#define T_YIELD	0
 */
#define T_DONE	1	/* no more please */
#define T_PART	2
#define T_CONT	0	/* keep going */

#define T_CLIPPED 0	/* command is empty as a result of a modification */
#define T_MERGED 2	/* command was merged while trying to queue it */
#define T_COPIED 2	/* command had to be copied anyway (thincBufferCmd) */

#ifdef EXIT_FAILURE
#define T_EXIT_FAIL	EXIT_FAILURE
#else
#define T_EXIT_FAIL	1
#endif
#ifdef EXIT_SUCCESS
#define T_EXIT_OK	EXIT_SUCCESS
#else
#define T_EXIT_OK	0
#endif

/* useful macros */
#include <endian.h>
#include <stdint.h>
#include <netinet/in.h>

#ifndef htonll
# if __BYTE_ORDER == __BIG_ENDIAN
#  define htonll(x) (x)
#  define ntohll(x) (x)
# else
#  define htonll(x) ((((uint64_t)htonl(x)) << 32) + htonl(x >> 32))
#  define ntohll(x) ((((uint64_t)ntohl(x)) << 32) + ntohl(x >> 32))
# endif
#endif

#ifndef ntohll
# if __BYTE_ORDER == __BIG_ENDIAN
#  define ntohll(x) (x)
#  define ntohll(x) (x)
# else
#  define ntohll(x) ((((uint64_t)ntohl(x)) << 32) + ntohl(x >> 32))
#  define ntohll(x) ((((uint64_t)ntohl(x)) << 32) + ntohl(x >> 32))
# endif
#endif

#endif /* _THINC_COMMON_H_ */
