/**************************************************************************
 *
 * Copyright 2002-2006 Columbia University
 * All Rights Reserved
 *
 **************************************************************************/
/* 
 * Cache protocol for THINC
 *
 * Authors: 
 * Ricardo Baratto - Network Computing Lab - Columbia University
 */
/* set tabstop = 8 */

#ifndef _THINC_PROTO_CACHE_H_
#define _THINC_PROTO_CACHE_H_

/*************************************************************************
 *                          SERVER => CLIENT                             *
 *************************************************************************/
/* T_FB_CACHE_DATA
 * Description: Wrapper for a cached update. Goes inside an update
 * message, and tells the client that the data for this particular update
 * can be found in the cache. The cache id is enclosed in this message.
 * Size: 4 bytes
 * Data: None
 */
typedef struct thinc_cacheData_s {
	int cache_id:32;
} thinc_cacheData;

#define T_FB_CACHE_DATA_SIZE	4

/* T_FB_ADD_CACHE:
 * Description: The update wrapping this message should be added to the
 * client's cache. The id to use is passed in this message.
 * Size: 4 bytes
 * Data: None
 */
typedef struct thinc_cacheAdd_s {
	int cache_id:32;
} thinc_cacheAdd;

#define T_FB_CACHE_ADD_SIZE	4

#endif
