#!/usr/bin/perl -w

# I really can't remember what this code does.
#
# Released to the public domain. You may use this
# code any way you wish, private, educational, or commercial.  It's free.

use strict;
use Getopt::Std;

use vars qw($opt_d);
my $debug;

getopts('d');

if($opt_d) { $debug = 1; } else { $debug = 0; }

my $infile = shift or die "no input file\n";

open(INFILE, "$infile") or die "can't open $infile: $!\n";

my ($count, $avg_cmds, $avg_over, $max_cmds, $max_over);
$count = $avg_cmds = $avg_over = $max_cmds = $max_over = 0;

while(<INFILE>) {
	if(!/Overwrite/) {
		next;
	}

	chomp;

	$count++;
	if(!$debug) { print "$count\r"; }
	s/\(II\) //;
	s/\([0-9][0-9]:[0-9][0-9]:[0-9][0-9]\) //;

	s/had//;
	s/commands//;
	s/,//;
	s/overwrote//;
	s/of them//;

	my ($over, $c, $o) = split;

	$avg_cmds += $c;
	$avg_over += $o;

	if($max_cmds < $c) { $max_cmds = $c; }
	if($max_over < $o) { $max_over = $o; }

	if($debug) { print "$count: $c $o $o\n"; }
}
print "\n";

close(INFILE);

$avg_cmds /= $count;
$avg_over /= $count;

print "\noverwrite stats from parsing the log:\n";
print "count: $count\n";
printf "avg queue length: %.2f\n", $avg_cmds;
printf "max queue lenght: %d\n", $max_cmds;
printf "avg overwrites per call: %.2f\n", $avg_over;
printf "max overwrites: %d\n", $max_over;

print "\nand that is that.\n";
