/*
 * I really can't remember what this code does.
 *
 * Released to the public domain. You may use this
 * code any way you wish, private, educational, or commercial.  It's free.
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/time.h>
#include <time.h>

#define gettime_ms(t) { \
        struct timeval tv;              \
        gettimeofday(&tv, NULL);        \
        t = (tv.tv_sec*1000) + (tv.tv_usec/1000); \
}

unsigned char* pack(unsigned char *unpacked, unsigned int pixels)
{
	unsigned int i;
	unsigned char *packed, *red, *green, *blue, *from;

	packed = malloc(pixels*3*sizeof(unsigned char));
	red = packed;
	green = red+pixels;
	blue = green+pixels;

	from = unpacked;
	for(i=0; i<pixels; ++i) {
		*red++ = from[0];
		*green++ = from[1];
		*blue++ = from[2];
		from+=4;
	}
	return packed;
}

unsigned char* pack2(unsigned char *unpacked, unsigned int pixels)
{
	unsigned int i;
	unsigned char *packed, *from, *to;

	packed = malloc(pixels*3*sizeof(unsigned char));
	from = unpacked;
	to = packed;
	for(i=0; i<pixels; ++i) {
		to[0] = from[0];
		to[1] = from[1];
		to[2] = from[2];
		from+=4;
		to+= 3;
	}
	return packed;
}

int main(int argc, char **argv) 
{
	FILE *f;
	unsigned int w, h, size, pixels, i, j;
	unsigned char *unpacked, *packed;
	int err;

	if(argc != 4) {
		printf("usage: %s <input> <output1> <output2>\n", argv[0]);
		return 1;
	}

	f = fopen(argv[1], "r");
	if(!f) {
		printf("%s: couldn't open %s: %s\n", argv[0], argv[1],
			strerror(errno));
		return 1;
	}

	fread(&w, sizeof(w), 1, f);
	fread(&h, sizeof(h), 1, f);
	printf("%s: got info: w %u, h %u\n", argv[0], w, h);
	pixels = w*h;
	size = pixels*4;

	printf("original size is %d, number of pixels %d\n", size, pixels);

	unpacked = malloc(size * sizeof(unsigned char));
	if(!unpacked) {
		printf("%s: couldn't allocate image data\n", argv[0]);
		return 1;
	}

	err = fread(unpacked, sizeof(unsigned char), size, f);
	if(err == -1) {
		printf("%s: couldn't read image unpacked: %s\n", argv[0],
			strerror(errno));
		return 1;
	}
	fclose(f);
	packed = pack(unpacked, pixels);
	f = fopen(argv[2], "w");
	if(!f) {
		printf("%s: couldn't open %s: %s\n", argv[0], argv[1],
			strerror(errno));
		return 1;
	}
	fwrite(packed, sizeof(unsigned char), pixels*3, f);
	fclose(f);
	free(packed);
	packed = pack2(unpacked, pixels);
	f = fopen(argv[3], "w");
	if(!f) {
		printf("%s: couldn't open %s: %s\n", argv[0], argv[1],
			strerror(errno));
		return 1;
	}
	fwrite(packed, sizeof(unsigned char), pixels*3, f);
	fclose(f);
	free(unpacked);

	return 0;
}
